import { Request, Response, NextFunction } from "express";
import request from "request-promise-native";
import { Response as Res } from "request";

export async function get(req : Request, res : Response, next: NextFunction) {
    const CALLBACK_URL = encodeURIComponent(`${process.env.ADMIN_URL}/login/discord/callback`);

    if(!req.query.code)
        throw new Error("NoCodeProvided");

    let code = req.query.code;
    let response = await request(`https://discordapp.com/api/oauth2/token?grant_type=authorization_code&code=${code}&redirect_uri=${CALLBACK_URL}`, {
        method: "POST",
        auth: {
            user: process.env.BOT_CLIENT_ID,
            pass: process.env.BOT_CLIENT_SECRET,
            sendImmediately: true
        },
        resolveWithFullResponse: true
    }) as Res;

    //TODO: Saving the tokens with horses and stuff
    console.log(response.toJSON());
};